using System;
using System.Collections.Generic;

class Program
{
    static void Main()
    {
        string[] dimenzije = Console.ReadLine().Split();
        int N = int.Parse(dimenzije[0]);
        int M = int.Parse(dimenzije[1]);

        char[,] lavirint = new char[N, M];
        int stevaX = -1, stevaY = -1;
        int[] vatraX = new int[N * M];
        int[] vatraY = new int[N * M];
        int brojvatri = 0;

        for(int i=0; i<N; i++)
        {
            string red = Console.ReadLine();
            for(int j=0; j<M; j++)
            {
                lavirint[i, j] = red[j];
                if (red[j] == 'S')
                {
                    stevaX = i;
                    stevaY = j;
                }
                else if (red[j] == 'X')
                {
                    vatraX[brojvatri] = i;
                    vatraY[brojvatri] = j;
                    brojvatri++;
                }
            }
        }
        int[,] vremevatre = new int[N,M];
        for(int i =0; i <N;i++)
        {
            for(int j = 0; j <M; j++)
            {
                vremevatre[i,j] = int.MaxValue;
            }
        }
        for (int i = 0; i < brojvatri; i++)
        {
            vremevatre[vatraX[i], vatraY[i]] = 0;
        }
        //za dalje ne mogu da se snadjem :(